#<profile4xi profile = "10" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "prepare4xi.py">
#<abstract4xi abstract = "provides function prepare4xi"/>
#<refer4xi reference = "forking.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'prepare4xi' ] 
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
try:                 # system ones
    import os
    import sys
    import signal
except:
    pass
try:                 # threading ones       
    import threading                
    import _thread   
except:
    pass
try:                 # winapi
    import _winapi
    from _winapi import WAIT_OBJECT_0, WAIT_TIMEOUT, INFINITE
except ImportError:
    if sys.platform == 'win32':
        raise
    _winapi = None
try:                 # imported-as ones 
    from pickle import _Pickler as Pickler          
except:
    pass            
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
from multiprocessing import forking
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
import constant_process4xi
from current_process4xi import set_authkey_current_process4xi
from current_process4xi import get_authkey_current_process4xi
from current_process4xi import set_name_current_process4xi
from current_process4xi import get_name_current_process4xi
from logger4xi import Logger4Xi
from logger4xi import get_log_to_stderr4xi
from logger4xi import set_log_to_stderr4xi
from logger4xi import get_logger4xi
from logger4xi import set_logger4xi 
from original_dir4xi import set_original_dir4xi
from original_dir4xi import get_original_dir4xi
from print4xi import print4xi
from time4xi import time4xi
#"
#/>


# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
old_main_modules = []
#"
#"/>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "prepare4xi" usage = "
#    forking.py
#        main:
#            preparation_data = load(from_parent)
#            prepare(preparation_data)
#    popen4xi.py:
#        prepare4xi(preparation_data2xi)
#"> 
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def prepare4xi(data):
    '''
    tries to get current process ready to unpickle process object
    '''
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------     

    class2print = "prepare4xi"
    method2print = "prepare4xi"
                
    # -----------------------------------------------------------------------------------------    
    # (Step 1/21) 
    # -----------------------------------------------------------------------------------------        
    message2print = "{(Step 1/22a) started" + "; prepare4xi-started: " + str(prepare4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
        
    message2print = "{(Step 1/22b) passed" + "; data-passed-to-prepare4xi: " + str(data) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
    #               
         
    # -----------------------------------------------------------------------------------------    
    # (Step 2/21)
    # -----------------------------------------------------------------------------------------        
    message2print = "{(Step 2/22a) passing" + "; main-passing-to-old-main-modules-append-by-prepare4xi: " + str(sys.modules['__main__']) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)          
        
           
    old_main_modules.append(sys.modules['__main__'])
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------     

    if 'name' in data:
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
         
        message2print = "{(Step 2/22b) passing" + "; data-passing-to-set-name-current-process4xi-by-prepare4xi: " + str(data['name']) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
                
                
        set_name_current_process4xi(data['name']) #dragonized
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
      
        message2print = "{(Step 2/22c) performed" + "; set-name-current-process4xi-performed-by-prepare4xi: " + str(set_name_current_process4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
                        
    # -----------------------------------------------------------------------------------------    
    # (Step 3/21)
    # -----------------------------------------------------------------------------------------        
        
    if 'authkey' in data:
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
         
        message2print = "{(Step 3/22a) passing" + "; data-passing-to-set-authkey-current_process4xi-by-prepare4xi: " + str(data['authkey']) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
        
            
        set_authkey_current_process4xi(data['authkey']) #dragonized
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
     
        message2print = "{(Step 3/22b) performed" + "; set-authkey-current-process4xi-performed-by-prepare4xi: " + str(set_authkey_current_process4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
                        
    # -----------------------------------------------------------------------------------------    
    # (Step 4/21)
    # -----------------------------------------------------------------------------------------        
        
    if 'log_to_stderr' in data and data['log_to_stderr']:
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
         
        log_to_stderr4xi()
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
             
        message2print = "{(Step 4/21) performed" + "; log-to-stderr4xi-performed-by-prepare4xi: " + str(log_to_stderr4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
           
                
    # -----------------------------------------------------------------------------------------    
    # (Step 5/21)
    # -----------------------------------------------------------------------------------------        
        
    if 'log_level' in data:
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
         
        get_logger4xi().setLevel(data['log_level'])
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
             
        message2print = "{(Step 5/21) performed" + "; get-logger4xi-performed-by-prepare4xi: " + str(get_logger4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
           
                
    # -----------------------------------------------------------------------------------------    
    # (Step 6/21)
    # -----------------------------------------------------------------------------------------        
        
    if 'sys_path' in data:
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
         
        sys.path = data['sys_path']
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
             
        message2print = "{(Step 6/21) set" + "; sys-path-set-by-prepare4xi to: " + str(sys.path)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
                   
                
    # -----------------------------------------------------------------------------------------    
    # (Step 7/21)
    # -----------------------------------------------------------------------------------------        
        
    if 'sys_argv' in data:
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
         
        sys.argv = data['sys_argv']    
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
      
        message2print = "{(Step 7/21) set" + "; sys-argv-set-by-prepare4xi to: " + str(sys.argv)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
        
                
    # -----------------------------------------------------------------------------------------    
    # (Step 8/21)
    # -----------------------------------------------------------------------------------------        
       
    if 'dir' in data:
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
         
        message2print = "{(Step 8/22a) passing" + "; data-passing-to-os-chdir-by-prepare4xi: " + str(data['dir']) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
        
            
        os.chdir(data['dir'])
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
           
        message2print = "{(Step 8/22b) performed" + "; os-chdir-performed-by-prepare4xi: " + str(os.chdir) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
                       
                
    # -----------------------------------------------------------------------------------------    
    # (Step 9/21)
    # -----------------------------------------------------------------------------------------        
       
    if 'orig_dir' in data:
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
         
        message2print = "{(Step 9/22a) passing" + "; data-passing-to-set-original-dir4xi-by-prepare4xi: " + str(data['orig_dir']) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
                
                    
        set_original_dir4xi(data['orig_dir'])
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
                   
        message2print = "{(Step 9/22b) performed" + "; set-original-dir4xi-performed-by-prepare4xi: " + str(set_original_dir4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
                        
       

    if 'main_path' in data:
             
        # -------------------------------------------------------------------------------------    
        # (Step 10/21)
        # -------------------------------------------------------------------------------------         
           
        main_path = data['main_path']
        
        message2print = "{(Step 10/21) set" + "; main-path-set-by-prepare4xi to: " + str(main_path)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
                
             
        # -------------------------------------------------------------------------------------    
        # (Step 11/21)
        # -------------------------------------------------------------------------------------         
        
        message2print = "{(Step 11/22a) passing" + "; path-passing-to-os-path-splitext-by-prepare4xi: " + str(os.path.basename(main_path)) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
        
                
        main_name = os.path.splitext(os.path.basename(main_path))[0]
      
        message2print = "{(Step 11/22b) set" + "; main-name-set-by-prepare4xi to: " + str(main_name)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
              
        # -------------------------------------------------------------------------------------    
        # (Step 12/21)
        # -------------------------------------------------------------------------------------         
        
        if main_name == '__init__':
   
            # -------------------------------------------------------------------------------------    
            #
            # -------------------------------------------------------------------------------------     
            
            message2print = "{(Step 12/22a) passing" + "; dirname-passing-to-os-path-basename-by-prepare4xi: " + str(os.path.dirname(main_path)) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)          
           
        
            main_name = os.path.basename(os.path.dirname(main_path))
   
            # -------------------------------------------------------------------------------------    
            #
            # -------------------------------------------------------------------------------------     
          
            message2print = "{(Step 12/22b) set" + "; main-name-set-by-prepare4xi to: " + str(main_name)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)          
                 
        
        # -------------------------------------------------------------------------------------    
        # (Step 13/21)
        # -------------------------------------------------------------------------------------         
        
        if main_name != 'ipython':
            import imp
            
            # ---------------------------------------------------------------------------------    
            # (Step 14/21)
            # ---------------------------------------------------------------------------------         
     
            if main_path is None:

                # ---------------------------------------------------------------------------------    
                #
                # ---------------------------------------------------------------------------------     
            
                dirs = None
                      
                message2print = "{(Step 13/22a) set" + "; dirs-set-by-prepare4xi to: " + str(dirs)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)          
   
            # -------------------------------------------------------------------------------------    
            #
            # -------------------------------------------------------------------------------------     
       
            elif os.path.basename(main_path).startswith('__init__.py'):

                # ---------------------------------------------------------------------------------    
                #
                # ---------------------------------------------------------------------------------     
                        
                message2print = "{(Step 13/22b) passing" + "; dirname-passing-to-os-path-dirname-by-prepare4xi: " + str(os.path.dirname(main_path)) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)          
   
            
                dirs = [os.path.dirname(os.path.dirname(main_path))]

                # ---------------------------------------------------------------------------------    
                #
                # ---------------------------------------------------------------------------------     
                      
                message2print = "{(Step 13/22c) set" + "; dirs-set-by-prepare4xi to: " + str(dirs)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)          
   
            # -------------------------------------------------------------------------------------    
            #
            # -------------------------------------------------------------------------------------     
       
            else:

                # ---------------------------------------------------------------------------------    
                #
                # ---------------------------------------------------------------------------------     
                        
                message2print = "{(Step 13/22d) passing" + "; main-path-passing-to-os-path-dirname-by-prepare4xi: " + str(main_path) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)          
               
            
                dirs = [os.path.dirname(main_path)]

                # ---------------------------------------------------------------------------------    
                #
                # ---------------------------------------------------------------------------------     

      
                message2print = "{(Step 13/22e) set" + "; dirs-set-by-prepare4xi to: " + str(dirs)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)          
                     
            # ---------------------------------------------------------------------------------    
            # (Step 15/21)
            # ---------------------------------------------------------------------------------         
                     
            assert main_name not in sys.modules, main_name
            
            message2print = "{(Step 15/21) asserted" + "; main-name-asserted-by-prepare4xi: " + str(main_name) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)             
                    
            # ---------------------------------------------------------------------------------    
            # (Step 16/21)
            # ---------------------------------------------------------------------------------         
        
            message2print = "{(Step 16/22a) passing" + "; main-name-passing-to-imp-find-module-by-prepare4xi: " + str(main_name) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)          
        
            message2print = "{(Step 16/22b) passing" + "; dirs-passing-to-imp-find-module-by-prepare4xi: " + str(dirs) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)          
                       
            file, path_name, etc = imp.find_module(main_name, dirs)
   
            # -------------------------------------------------------------------------------------    
            #
            # -------------------------------------------------------------------------------------     
                
      
            message2print = "{(Step 16/22c) set" + "; file-set-by-prepare4xi to: " + str(file)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)          
      
            message2print = "{(Step 16/22d) set" + "; path-name-set-by-prepare4xi to: " + str(path_name)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)          
      
            message2print = "{(Step 16/22e) set" + "; etc-set-by-prepare4xi to: " + str(etc)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)          
                           
            # ---------------------------------------------------------------------------------    
            # (Step 17/21)
            # ---------------------------------------------------------------------------------         
                 
            try:

                # ---------------------------------------------------------------------------------    
                #
                # ---------------------------------------------------------------------------------     
            
                # We would like to do "imp.load_module('__main__', ...)"
                # here.  However, that would cause 'if __name__ ==
                # "__main__"' clauses to be executed.
                
        
                message2print = "{(Step 17/22a) passing" + "; file-passing-to-imp-load-module-by-prepare4xi: " + str(file) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)          
                          
        
                message2print = "{(Step 17/22b) passing" + "; path-name-passing-to-imp-load-module-by-prepare4xi: " + str(path_name) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)          
        
                message2print = "{(Step 17/22c) passing" + "; etc-passing-to-imp-load-module-by-prepare4xi: " + str(etc) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)          
                      
                
                main_module = imp.load_module(
                    '__parents_main__', file, path_name, etc
                    )

                # ---------------------------------------------------------------------------------    
                #
                # ---------------------------------------------------------------------------------     
                
                message2print = "{(Step 17/22d) created" + "; main-module-created-by-prepare4xi: " + str(main_module) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)         
                            
                    
            finally:

                # ---------------------------------------------------------------------------------    
                #
                # ---------------------------------------------------------------------------------     
            
                message2print = "{(Step 17/22e) checking" + "; file-checking-by-prepare4xi: " + str(file) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)           
                    
                if file:
    
                    # -----------------------------------------------------------------------------    
                    #
                    # ----------------------------------------------------------------------------- 
                
                    file.close()
                    
                    message2print = "{(Step 17/22f) performed" + "; file-close-performed-by-prepare4xi: " + str(file.close) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)             

                # ---------------------------------------------------------------------------------    
                #
                # ---------------------------------------------------------------------------------     
                            
                      
            # ---------------------------------------------------------------------------------    
            # (Step 18/21)
            # ---------------------------------------------------------------------------------         
     
            sys.modules['__main__'] = main_module
            
      
            message2print = "{(Step 18/21) set" + "; sys-modules-set-by-prepare4xi to: " + str(sys.modules['__main__'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)          
    
            # ---------------------------------------------------------------------------------    
            # (Step 19/21)
            # ---------------------------------------------------------------------------------         
                         
            main_module.__name__ = '__main__'

      
            message2print = "{(Step 19/21) set" + "; main-module-name-set-by-prepare4xi to: " + str(main_module.__name__)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)          
               

            # ---------------------------------------------------------------------------------    
            # (Step 20/21)
            # ---------------------------------------------------------------------------------         
                           
                        
            # Try to make the potentially picklable objects in
            # sys.modules['__main__'] realize they are in the main
            # module -- somewhat ugly.
            for obj in list(main_module.__dict__.values()):

                # ---------------------------------------------------------------------------------    
                #
                # ---------------------------------------------------------------------------------     
                message2print = "{(Step 20/21a) got" + "; object-got-by-prepare4xi: " + str(obj)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                                
                        
                try:
    
                    # -----------------------------------------------------------------------------    
                    #
                    # ----------------------------------------------------------------------------- 
         
                    if obj.__module__ == '__parents_main__':
    
                        # -------------------------------------------------------------------------    
                        #
                        # ------------------------------------------------------------------------- 
                    
                        obj.__module__ = '__main__'
      
                        message2print = "{(Step 20/21b) set" + "; object-module-set-by-prepare4xi to: " + str(obj.__module__)  + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)          
    
                    # -----------------------------------------------------------------------------    
                    #
                    # ----------------------------------------------------------------------------- 

                # ---------------------------------------------------------------------------------    
                #
                # ---------------------------------------------------------------------------------     
                             
                except Exception:
    
                    # -----------------------------------------------------------------------------    
                    #
                    # ----------------------------------------------------------------------------- 
                
                    message2print = "{(Step 20/21c) hit" + "; Exception-hit-by-prepare4xi: " + " *** failed to set module for objects: " + str(obj) + " *** " + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)
                        
                    pass  

                # ---------------------------------------------------------------------------------    
                #
                # ---------------------------------------------------------------------------------     
      
                                 
                      
        # -------------------------------------------------------------------------------------    
        # (Step 22/21)
        # -------------------------------------------------------------------------------------         
        message2print = "{(Step 21/21) returning" + "; prepare4xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)
                     
#</function4xi>
#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_none4xi.txt
#   sense-test-none4xi.xml
#   reason-test-none4xi.xml
#   ace-test-none4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 
#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of prepare4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>

